# -*- python -*-
# $RCSfile: gui_utils.py,v $
# $Revision: 1.9 $
# $Author: langer $
# $Date: 2005/05/13 18:43:50 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# GUI utility functions.

from oof2.common import debug
from oof2.common import guitop
from gtk import *

# Function for fixing a GtkOptionMenu's size stuff.  Operates on its
# first argument if it gets one, otherwise it creates a new
# GtkOptionMenu, sizes it, and returns it.  Second argument is the
# desired width in characters to be accommodated.  We guess that "N"
# is an average-width character for most fonts, and use that to set
# the width.
def SizedOptionMenu(gtkoptmenu=None, charwidth=0):
    debug.mainthreadTest()
    if guitop.top():
        font = guitop.top().gtk.get_style().font
        height = font.height('Ggpjy')*2
        if charwidth>0:
            width = font.width("N"*charwidth)+20
        else:
            width = -1
        if gtkoptmenu:
            gtkoptmenu.set_usize(width, height)
            return gtkoptmenu
        else:
            newgtkom = GtkOptionMenu()
            newgtkom.set_usize(width, height)
            return newgtkom

    # If the gui hasn't been started yet, there's no way to get the
    # font size, so we just return an unsized widget and hope for the
    # best.
    return GtkOptionMenu()
