/*
 * FILE : SRC/common/IO/GUI/oofcanvascmodule.C
 * 
 * This file was automatically generated by :
 * Simplified Wrapper and Interface Generator (SWIG)
 * Version 1.1 (Build 883)
 * 
 * Portions Copyright (c) 1995-1998
 * The University of Utah and The Regents of the University of California.
 * Permission is granted to distribute this file in any manner provided
 * this notice remains intact.
 * 
 * Do not make changes to this file--changes will be lost!
 *
 */


#define SWIGCODE
/* Implementation : PYTHON */

#define SWIGPYTHON
// -*- C++ -*-
// $RCSfile: pyexp.swg,v $
// $Revision: 1.4 $
// $Author: reida $
// $Date: 2005/05/10 13:26:27 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

// This file (in this location) prevents _POSIX_C_SOURCE warnings when
// compiling SWIG-generated C code with compilers newer than gcc-2.95,
// or with Python versions newer than 2.1.

// It is a modified version of the SWIG-supplied pyexp.swg file.
// The only modification is the first include line, which includes
// Python.h before anythign else -- this gets inserted before the
// rest of any SWIG-generated C code, and prevents _POSIX_C_SOURCE
// redefinition warnings.

// This works because SWIG follows a rigid search path for this
// file, and putting the modified one in the SRC directory pre-empts
// the stock as-distributed one.


#include <Python.h>
#include <string.h>
#include <stdlib.h>
/* Definitions for Windows/Unix exporting */
#if defined(__WIN32__)
#   if defined(_MSC_VER)
#	define SWIGEXPORT(a) __declspec(dllexport) a
#   else
#	if defined(__BORLANDC__)
#	    define SWIGEXPORT(a) a _export 
#	else
#	    define SWIGEXPORT(a) a 
#	endif
#   endif
#else
#   define SWIGEXPORT(a) a 
#endif

#ifdef __cplusplus
extern "C" {
#endif
#include "Python.h"
extern void SWIG_MakePtr(char *, void *, char *);
extern void SWIG_RegisterMapping(char *, char *, void *(*)(void *));
extern char *SWIG_GetPtr(char *, void **, char *);
extern char *SWIG_GetPtrObj(PyObject *, void **, char *);
extern void SWIG_addvarlink(PyObject *, char *, PyObject *(*)(void), int (*)(PyObject *));
extern PyObject *SWIG_newvarlink(void);
#ifdef __cplusplus
}
#endif
#define SWIG_init    initoofcanvasc

#define SWIG_name    "oofcanvasc"

#include <Python.h>	
#include "common/ooferror.h"
#include "common/cdebug.h"
#include "common/IO/threadstate.h"

#include <vector>
  typedef std::vector<double> DoubleVec;
  typedef std::vector<int> IntVec;
  typedef std::vector<unsigned short> ShortVec;

#include "common/geometry.h"
#include <vector>
  typedef std::vector<Coord*> CoordVec;
  typedef std::vector<Coord> PointVec;
  typedef std::vector<CSegment*> CSegmentVec;
  typedef std::vector<ICoord> ICoordVec;
  typedef std::vector<std::string> StringVec;
  typedef std::vector<char*> CharPtrVec;

#include <string>
using std::string;

#include "common/IO/GUI/oofcanvas.h"
#include "common/ooferror.h"
#include "common/IO/GUI/rubberband.h"
typedef std::vector<GtkCanvasPoints*> GtkPointVec;
typedef std::vector<gushort> ColorVec;
#define NO_IMPORT_PYGDKIMLIB
#include <pygtk/pygdkimlib.h>
#undef NO_IMPORT_PYGDKIMLIB


  // Convert a Segment of Coords or Points into a GtkCanvasPoints struct.
  static GtkCanvasPoints *segment2gtk(PyObject *segment) {
    GtkCanvasPoints *pts = gtk_canvas_points_new(2); // must be freed elsewhere
    PyObject *start = PyObject_CallMethod(segment, "start", NULL);
    PyObject *endpt = PyObject_CallMethod(segment, "end", NULL);
    if(PyObject_HasAttrString(start, "this")) {
      // The Segment is made of swigged objects, which must be Coords
      Coord *cstart=0, *cend=0;
      PyObject *sobj = PyObject_GetAttrString(start, "this");
      char *str = PyString_AsString(sobj);
      Py_XDECREF(sobj);
      if(SWIG_GetPtr(str, (void**) &cstart, "_Coord_p")) {
	PyErr_SetString(PyExc_TypeError,
			"Type error in segment2gtk.  Expected _Coord_p");
	return NULL;
      }
      sobj = PyObject_GetAttrString(endpt, "this");
      str = PyString_AsString(sobj);
      Py_XDECREF(sobj);
      if(SWIG_GetPtr(str, (void**) &cend, "_Coord_p")) {
	PyErr_SetString(PyExc_TypeError,
			"Type error in segment2gtk.  Expected _Coord_p");
	return NULL;
      }
      pts->coords[0] = (*cstart)(0);
      pts->coords[1] = (*cstart)(1);
      pts->coords[2] = (*cend)(0);
      pts->coords[3] = (*cend)(1);
    }	
    else {
      PyObject *x0 = PyObject_GetAttrString(start, "x");
      PyObject *y0 = PyObject_GetAttrString(start, "y");
      PyObject *x1 = PyObject_GetAttrString(endpt, "x");
      PyObject *y1 = PyObject_GetAttrString(endpt, "y");
      if(!(x0 && y0 && x1 && y1)) {
	PyErr_SetString(PyExc_AttributeError,
			"Segment component doesn't have x and y attributes.");
	return NULL;
      }
      pts->coords[0] = PyFloat_AsDouble(x0);
      pts->coords[1] = PyFloat_AsDouble(y0);
      pts->coords[2] = PyFloat_AsDouble(x1);
      pts->coords[3] = PyFloat_AsDouble(y1);
      Py_XDECREF(x0);
      Py_XDECREF(y0);
      Py_XDECREF(x1);
      Py_XDECREF(y1);
    }
    Py_XDECREF(start);
    Py_XDECREF(endpt);
    return pts;
  }
#ifdef __cplusplus
extern "C" {
#endif
#define new_OOFCanvas(_swigarg0) (new OOFCanvas(_swigarg0))
static PyObject *_wrap_new_OOFCanvas(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _result;
    bool  _arg0;
    int tempbool0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"i:new_OOFCanvas",&tempbool0)) 
        return NULL;
    _arg0 = (bool ) tempbool0;
{
  try {
    installSignals;
    releasePyLock();
        _result = (OOFCanvas *)new_OOFCanvas(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    if (_result) {
        SWIG_MakePtr(_ptemp, (char *) _result,"_OOFCanvas_p");
        _resultobj = Py_BuildValue("s",_ptemp);
    } else {
        Py_INCREF(Py_None);
        _resultobj = Py_None;
    }
    return _resultobj;
}

#define delete_OOFCanvas(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_OOFCanvas(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:delete_OOFCanvas",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_OOFCanvas. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        delete_OOFCanvas(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_add_self(_swigobj,_swigarg0)  (_swigobj->add_self(_swigarg0))
static PyObject *_wrap_OOFCanvas_add_self(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _arg1;
    PyObject * _argo0 = 0;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_add_self",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_add_self. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  _arg1 = _obj1;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_add_self(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_attach_self_to_table(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7,_swigarg8)  (_swigobj->attach_self_to_table(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6,_swigarg7,_swigarg8))
static PyObject *_wrap_OOFCanvas_attach_self_to_table(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _arg1;
    guint * _arg2;
    guint * _arg3;
    guint * _arg4;
    guint * _arg5;
    GtkAttachOptions * _arg6;
    GtkAttachOptions * _arg7;
    guint * _arg8;
    guint * _arg9;
    PyObject * _argo0 = 0;
    PyObject * _obj1 = 0;
    guint  tmp;
    PyObject * _obj2 = 0;
    guint  tmp0;
    PyObject * _obj3 = 0;
    guint  tmp1;
    PyObject * _obj4 = 0;
    guint  tmp2;
    PyObject * _obj5 = 0;
    GtkAttachOptions  tmp3;
    PyObject * _obj6 = 0;
    GtkAttachOptions  tmp4;
    PyObject * _obj7 = 0;
    guint  tmp5;
    PyObject * _obj8 = 0;
    guint  tmp6;
    PyObject * _obj9 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OOOOOOOOOO:OOFCanvas_attach_self_to_table",&_argo0,&_obj1,&_obj2,&_obj3,&_obj4,&_obj5,&_obj6,&_obj7,&_obj8,&_obj9)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_attach_self_to_table. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  _arg1 = _obj1;
}
{
  tmp = (guint) PyInt_AsLong(_obj2);
  _arg2 = &tmp;
}
{
  tmp0 = (guint) PyInt_AsLong(_obj3);
  _arg3 = &tmp0;
}
{
  tmp1 = (guint) PyInt_AsLong(_obj4);
  _arg4 = &tmp1;
}
{
  tmp2 = (guint) PyInt_AsLong(_obj5);
  _arg5 = &tmp2;
}
{
  tmp3 = (GtkAttachOptions) PyInt_AsLong(_obj6);
  _arg6 = &tmp3;
}
{
  tmp4 = (GtkAttachOptions) PyInt_AsLong(_obj7);
  _arg7 = &tmp4;
}
{
  tmp5 = (guint) PyInt_AsLong(_obj8);
  _arg8 = &tmp5;
}
{
  tmp6 = (guint) PyInt_AsLong(_obj9);
  _arg9 = &tmp6;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_attach_self_to_table(_arg0,_arg1,_arg2,_arg3,_arg4,_arg5,_arg6,_arg7,_arg8,_arg9);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_close(_swigobj)  (_swigobj->close())
static PyObject *_wrap_OOFCanvas_close(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_close",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_close. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_close(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_get_pixels_per_unit(_swigobj)  (_swigobj->get_pixels_per_unit())
static PyObject *_wrap_OOFCanvas_get_pixels_per_unit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    double  _result;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_get_pixels_per_unit",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_get_pixels_per_unit. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (double )OOFCanvas_get_pixels_per_unit(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    _resultobj = Py_BuildValue("d",_result);
    return _resultobj;
}

#define OOFCanvas_set_pixels_per_unit(_swigobj,_swigarg0)  (_swigobj->set_pixels_per_unit(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_pixels_per_unit(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    double  _arg1;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"Od:OOFCanvas_set_pixels_per_unit",&_argo0,&_arg1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_pixels_per_unit. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_pixels_per_unit(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_zoom(_swigobj,_swigarg0)  (_swigobj->zoom(_swigarg0))
static PyObject *_wrap_OOFCanvas_zoom(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    double  _arg1;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"Od:OOFCanvas_zoom",&_argo0,&_arg1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_zoom. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_zoom(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_get_scrollregion(_swigobj)  (_swigobj->get_scrollregion())
static PyObject *_wrap_OOFCanvas_get_scrollregion(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    CRectangle * _result;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_get_scrollregion",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_get_scrollregion. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = new CRectangle (OOFCanvas_get_scrollregion(_arg0));
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    SWIG_MakePtr(_ptemp, (void *) _result,"_CRectangle_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define OOFCanvas_set_scrollregion(_swigobj,_swigarg0)  (_swigobj->set_scrollregion(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_scrollregion(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    CRectangle * _arg1;
    PyObject * _argo0 = 0;
    PyObject * _argo1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_set_scrollregion",&_argo0,&_argo1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_scrollregion. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
    if (_argo1) {
        if (_argo1 == Py_None) { _arg1 = NULL; }
        else if (SWIG_GetPtrObj(_argo1,(void **) &_arg1,"_CRectangle_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of OOFCanvas_set_scrollregion. Expected _CRectangle_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_scrollregion(_arg0,*_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_get_bounds(_swigobj)  (_swigobj->get_bounds())
static PyObject *_wrap_OOFCanvas_get_bounds(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    CRectangle * _result;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_get_bounds",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_get_bounds. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = new CRectangle (OOFCanvas_get_bounds(_arg0));
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    SWIG_MakePtr(_ptemp, (void *) _result,"_CRectangle_p");
    _resultobj = Py_BuildValue("s",_ptemp);
    return _resultobj;
}

#define OOFCanvas_get_width_in_pixels(_swigobj)  (_swigobj->get_width_in_pixels())
static PyObject *_wrap_OOFCanvas_get_width_in_pixels(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_get_width_in_pixels",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_get_width_in_pixels. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (int )OOFCanvas_get_width_in_pixels(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define OOFCanvas_get_height_in_pixels(_swigobj)  (_swigobj->get_height_in_pixels())
static PyObject *_wrap_OOFCanvas_get_height_in_pixels(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    int  _result;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_get_height_in_pixels",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_get_height_in_pixels. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (int )OOFCanvas_get_height_in_pixels(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define OOFCanvas_world_coord(_swigobj,_swigarg0,_swigarg1)  (_swigobj->world_coord(_swigarg0,_swigarg1))
static PyObject *_wrap_OOFCanvas_world_coord(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Coord * _result;
    OOFCanvas * _arg0;
    int  _arg1;
    int  _arg2;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"Oii:OOFCanvas_world_coord",&_argo0,&_arg1,&_arg2)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_world_coord. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = new Coord (OOFCanvas_world_coord(_arg0,_arg1,_arg2));
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}{
  static PyObject *PointClass = 0;
  if(!PointClass) {
    PyObject *module = PyImport_ImportModule("oof2.common.primitives");
    PointClass = PyObject_GetAttrString(module, "Point");
    if(!PointClass) return NULL;
    Py_XINCREF(PointClass);
  }
  PyObject *xyargs = Py_BuildValue("dd", (*_result)(0), (*_result)(1));
  _resultobj = PyObject_CallObject(PointClass, xyargs);
  Py_XDECREF(xyargs);
}
    return _resultobj;
}

#define OOFCanvas_window_coord(_swigobj,_swigarg0)  (_swigobj->window_coord(_swigarg0))
static PyObject *_wrap_OOFCanvas_window_coord(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    Coord * _result;
    OOFCanvas * _arg0;
    Coord * _arg1;
    PyObject * _argo0 = 0;
    Coord  c;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_window_coord",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_window_coord. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *xobj = PyObject_GetAttrString(_obj1, "x");
  PyObject *yobj = PyObject_GetAttrString(_obj1, "y");
  if(!xobj || !yobj) {
    PyErr_SetString(PyExc_TypeError, "Type error in Coord *Point typemap.  Argument must have .x and .y attributes.");
    return NULL;
  }
  c(0) = PyFloat_AsDouble(xobj);
  c(1) = PyFloat_AsDouble(yobj);
  Py_XDECREF(xobj);
  Py_XDECREF(yobj);
  _arg1 = &c;
}
{
  try {
    installSignals;
    releasePyLock();
        _result = new Coord (OOFCanvas_window_coord(_arg0,_arg1));
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}{
  static PyObject *PointClass = 0;
  if(!PointClass) {
    PyObject *module = PyImport_ImportModule("oof2.common.primitives");
    PointClass = PyObject_GetAttrString(module, "Point");
    if(!PointClass) return NULL;
    Py_XINCREF(PointClass);
  }
  PyObject *xyargs = Py_BuildValue("dd", (*_result)(0), (*_result)(1));
  _resultobj = PyObject_CallObject(PointClass, xyargs);
  Py_XDECREF(xyargs);
}
    return _resultobj;
}

#define OOFCanvas_set_hadjustment(_swigobj,_swigarg0)  (_swigobj->set_hadjustment(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_hadjustment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _arg1;
    PyObject * _argo0 = 0;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_set_hadjustment",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_hadjustment. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  _arg1 = _obj1;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_hadjustment(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_set_vadjustment(_swigobj,_swigarg0)  (_swigobj->set_vadjustment(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_vadjustment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _arg1;
    PyObject * _argo0 = 0;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_set_vadjustment",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_vadjustment. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  _arg1 = _obj1;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_vadjustment(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_newLayer(_swigobj)  (_swigobj->newLayer())
static PyObject *_wrap_OOFCanvas_newLayer(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _result;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_newLayer",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_newLayer. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (OOFCanvasLayer *)OOFCanvas_newLayer(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    if (_result) {
        SWIG_MakePtr(_ptemp, (char *) _result,"_OOFCanvasLayer_p");
        _resultobj = Py_BuildValue("s",_ptemp);
    } else {
        Py_INCREF(Py_None);
        _resultobj = Py_None;
    }
    return _resultobj;
}

#define OOFCanvas_deleteLayer(_swigobj,_swigarg0)  (_swigobj->deleteLayer(_swigarg0))
static PyObject *_wrap_OOFCanvas_deleteLayer(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    OOFCanvasLayer * _arg1;
    PyObject * _argo0 = 0;
    PyObject * _argo1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_deleteLayer",&_argo0,&_argo1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_deleteLayer. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
    if (_argo1) {
        if (_argo1 == Py_None) { _arg1 = NULL; }
        else if (SWIG_GetPtrObj(_argo1,(void **) &_arg1,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of OOFCanvas_deleteLayer. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_deleteLayer(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_set_mouse_callback(_swigobj,_swigarg0)  (_swigobj->set_mouse_callback(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_mouse_callback(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _arg1;
    PyObject * _argo0 = 0;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_set_mouse_callback",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_mouse_callback. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  if(!PyCallable_Check(_obj1)) {
    PyErr_SetString(PyExc_TypeError,"Need a callable object!");
    return NULL;
  }
  _arg1 = _obj1;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_mouse_callback(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_set_configure_callback(_swigobj,_swigarg0)  (_swigobj->set_configure_callback(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_configure_callback(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _arg1;
    PyObject * _argo0 = 0;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_set_configure_callback",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_configure_callback. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  if(!PyCallable_Check(_obj1)) {
    PyErr_SetString(PyExc_TypeError,"Need a callable object!");
    return NULL;
  }
  _arg1 = _obj1;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_configure_callback(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_OOFCanvas_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_show",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_show. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_show(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_clear(_swigobj)  (_swigobj->clear())
static PyObject *_wrap_OOFCanvas_clear(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_clear",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_clear. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_clear(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_is_empty(_swigobj)  (_swigobj->is_empty())
static PyObject *_wrap_OOFCanvas_is_empty(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    bool  _result;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvas_is_empty",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_is_empty. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (bool )OOFCanvas_is_empty(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    _resultobj = Py_BuildValue("i",_result);
    return _resultobj;
}

#define OOFCanvas_set_lineWidth(_swigobj,_swigarg0)  (_swigobj->set_lineWidth(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_lineWidth(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    unsigned int  _arg1;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"Oi:OOFCanvas_set_lineWidth",&_argo0,&_arg1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_lineWidth. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_lineWidth(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_set_lineColor(_swigobj,_swigarg0)  (_swigobj->set_lineColor(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_lineColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    guint32 * _arg1;
    PyObject * _argo0 = 0;
    guint32  tmp;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_set_lineColor",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_lineColor. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *redobj = PyObject_CallMethod(_obj1, "getRed", NULL);
  PyObject *grnobj = PyObject_CallMethod(_obj1, "getGreen", NULL);
  PyObject *bluobj = PyObject_CallMethod(_obj1, "getBlue", NULL);
  if(!(redobj && grnobj && bluobj)) {
    PyErr_SetString(PyExc_TypeError, "guint32* typemap: Failed to evaluate Color.");
    return NULL;
  }
  unsigned char red = (unsigned char)(255*PyFloat_AsDouble(redobj));
  unsigned char grn = (unsigned char)(255*PyFloat_AsDouble(grnobj));
  unsigned char blu = (unsigned char)(255*PyFloat_AsDouble(bluobj));
 
  tmp = GTK_CANVAS_COLOR_A(red, grn, blu, 255); // 255=opaque
  _arg1 = &tmp;
  Py_XDECREF(redobj);
  Py_XDECREF(grnobj);
  Py_XDECREF(bluobj);
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_lineColor(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_set_fillColor(_swigobj,_swigarg0)  (_swigobj->set_fillColor(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_fillColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    guint32 * _arg1;
    PyObject * _argo0 = 0;
    guint32  tmp;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_set_fillColor",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_fillColor. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *redobj = PyObject_CallMethod(_obj1, "getRed", NULL);
  PyObject *grnobj = PyObject_CallMethod(_obj1, "getGreen", NULL);
  PyObject *bluobj = PyObject_CallMethod(_obj1, "getBlue", NULL);
  if(!(redobj && grnobj && bluobj)) {
    PyErr_SetString(PyExc_TypeError, "guint32* typemap: Failed to evaluate Color.");
    return NULL;
  }
  unsigned char red = (unsigned char)(255*PyFloat_AsDouble(redobj));
  unsigned char grn = (unsigned char)(255*PyFloat_AsDouble(grnobj));
  unsigned char blu = (unsigned char)(255*PyFloat_AsDouble(bluobj));
 
  tmp = GTK_CANVAS_COLOR_A(red, grn, blu, 255); // 255=opaque
  _arg1 = &tmp;
  Py_XDECREF(redobj);
  Py_XDECREF(grnobj);
  Py_XDECREF(bluobj);
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_fillColor(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_set_underlay_params(_swigobj,_swigarg0,_swigarg1)  (_swigobj->set_underlay_params(_swigarg0,_swigarg1))
static PyObject *_wrap_OOFCanvas_set_underlay_params(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    ColorVec * _arg1;
    double  _arg2;
    PyObject * _argo0 = 0;
    ColorVec  tmp;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OOd:OOFCanvas_set_underlay_params",&_argo0,&_obj1,&_arg2)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_underlay_params. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *redobj = PyObject_CallMethod(_obj1, "getRed", NULL);
  PyObject *grnobj = PyObject_CallMethod(_obj1, "getGreen", NULL);
  PyObject *bluobj = PyObject_CallMethod(_obj1, "getBlue", NULL);
  if(!(redobj && grnobj && bluobj)) {
    PyErr_SetString(PyExc_TypeError, "ColorVec* typemap: Failed to evaluate Color.");
    return NULL;
  }
  tmp.resize(3);
  tmp[0] = gushort(65535*PyFloat_AsDouble(redobj));
  tmp[1] = gushort(65535*PyFloat_AsDouble(grnobj));
  tmp[2] = gushort(65535*PyFloat_AsDouble(bluobj));
  _arg1 = &tmp;
  Py_XDECREF(redobj);
  Py_XDECREF(grnobj);
  Py_XDECREF(bluobj);
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_underlay_params(_arg0,_arg1,_arg2);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_set_bgColor(_swigobj,_swigarg0)  (_swigobj->set_bgColor(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_bgColor(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    ColorVec * _arg1;
    PyObject * _argo0 = 0;
    ColorVec  tmp;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_set_bgColor",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_bgColor. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *redobj = PyObject_CallMethod(_obj1, "getRed", NULL);
  PyObject *grnobj = PyObject_CallMethod(_obj1, "getGreen", NULL);
  PyObject *bluobj = PyObject_CallMethod(_obj1, "getBlue", NULL);
  if(!(redobj && grnobj && bluobj)) {
    PyErr_SetString(PyExc_TypeError, "ColorVec* typemap: Failed to evaluate Color.");
    return NULL;
  }
  tmp.resize(3);
  tmp[0] = gushort(65535*PyFloat_AsDouble(redobj));
  tmp[1] = gushort(65535*PyFloat_AsDouble(grnobj));
  tmp[2] = gushort(65535*PyFloat_AsDouble(bluobj));
  _arg1 = &tmp;
  Py_XDECREF(redobj);
  Py_XDECREF(grnobj);
  Py_XDECREF(bluobj);
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_bgColor(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_set_margin(_swigobj,_swigarg0)  (_swigobj->set_margin(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_margin(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    double  _arg1;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"Od:OOFCanvas_set_margin",&_argo0,&_arg1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_margin. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_margin(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_draw_dot(_swigobj,_swigarg0)  (_swigobj->draw_dot(_swigarg0))
static PyObject *_wrap_OOFCanvas_draw_dot(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    Coord * _arg1;
    PyObject * _argo0 = 0;
    Coord  c;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_draw_dot",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_draw_dot. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *xobj = PyObject_GetAttrString(_obj1, "x");
  PyObject *yobj = PyObject_GetAttrString(_obj1, "y");
  if(!xobj || !yobj) {
    PyErr_SetString(PyExc_TypeError, "Type error in Coord *Point typemap.  Argument must have .x and .y attributes.");
    return NULL;
  }
  c(0) = PyFloat_AsDouble(xobj);
  c(1) = PyFloat_AsDouble(yobj);
  Py_XDECREF(xobj);
  Py_XDECREF(yobj);
  _arg1 = &c;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_draw_dot(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_draw_triangle(_swigobj,_swigarg0,_swigarg1)  (_swigobj->draw_triangle(_swigarg0,_swigarg1))
static PyObject *_wrap_OOFCanvas_draw_triangle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    Coord * _arg1;
    double  _arg2;
    PyObject * _argo0 = 0;
    Coord  c;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OOd:OOFCanvas_draw_triangle",&_argo0,&_obj1,&_arg2)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_draw_triangle. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *xobj = PyObject_GetAttrString(_obj1, "x");
  PyObject *yobj = PyObject_GetAttrString(_obj1, "y");
  if(!xobj || !yobj) {
    PyErr_SetString(PyExc_TypeError, "Type error in Coord *Point typemap.  Argument must have .x and .y attributes.");
    return NULL;
  }
  c(0) = PyFloat_AsDouble(xobj);
  c(1) = PyFloat_AsDouble(yobj);
  Py_XDECREF(xobj);
  Py_XDECREF(yobj);
  _arg1 = &c;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_draw_triangle(_arg0,_arg1,_arg2);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_draw_segment(_swigobj,_swigarg0)  (_swigobj->draw_segment(_swigarg0))
static PyObject *_wrap_OOFCanvas_draw_segment(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    GtkCanvasPoints * _arg1;
    PyObject * _argo0 = 0;
    GtkCanvasPoints * pts;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_draw_segment",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_draw_segment. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  pts =  segment2gtk(_obj1);
  _arg1 = pts;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_draw_segment(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
{
  gtk_canvas_points_unref(pts);
}
    return _resultobj;
}

#define OOFCanvas_draw_segments(_swigobj,_swigarg0)  (_swigobj->draw_segments(_swigarg0))
static PyObject *_wrap_OOFCanvas_draw_segments(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    GtkPointVec * _arg1;
    PyObject * _argo0 = 0;
    GtkPointVec  ptvec;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_draw_segments",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_draw_segments. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  if(!PyList_Check(_obj1)) {
    PyErr_SetString(PyExc_TypeError, "Type error in GtkPointVec* typemap. Python list required.");
    return NULL;
  }
  int sz = PyList_Size(_obj1);
  ptvec.resize(sz);
  for(int i=0; i<sz; i++)
    ptvec[i] = segment2gtk(PyList_GET_ITEM(_obj1, i));
  _arg1 = &ptvec;
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_draw_segments(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
{
  for(int i=0; i<ptvec.size(); i++)
    gtk_canvas_points_unref(ptvec[i]);
}
    return _resultobj;
}

#define OOFCanvas_draw_curve(_swigobj,_swigarg0)  (_swigobj->draw_curve(_swigarg0))
static PyObject *_wrap_OOFCanvas_draw_curve(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    GtkCanvasPoints * _arg1;
    PyObject * _argo0 = 0;
    GtkCanvasPoints * pts;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_draw_curve",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_draw_curve. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *ptlist = PyObject_CallMethod(_obj1, "points", NULL);
  if(!PyList_Check(ptlist)) {
    PyErr_SetString(PyExc_TypeError, "Typemap snafu!");
    return NULL;
  }
  int sz = PyList_Size(ptlist);
  pts = gtk_canvas_points_new(sz);

  // Here we have to check to see if we have a List of Points or
  // Coords.  Points are Python objects with .x and .y members.
  // Coords are C++ objects already, but we have to decipher the SWIG
  // pointer to find out where they are.

  PyObject *firstpoint = PyList_GET_ITEM(ptlist, 0);
  if(PyObject_HasAttrString(firstpoint, "this")) {
    // The PyObject is a swigged object.  Assume it's a Coord.
    for(int i=0; i<sz; i++) {
      PyObject *swiggedcoord = PyList_GET_ITEM(ptlist, i);
      Coord *coord;
      PyObject *sobj = PyObject_GetAttrString(swiggedcoord, "this");
      char *str = PyString_AsString(sobj);
      Py_XDECREF(sobj);
      if(SWIG_GetPtr(str, (void**) &coord, "_Coord_p")) {
	PyErr_SetString(PyExc_TypeError,
			"Type error in curve typemap: expected _Coord_p");
	return NULL;
      }
      pts->coords[2*i] = (*coord)(0);
      pts->coords[2*i+1] = (*coord)(1);
    }
  }
  else {
    // We have a list of pure Python objects.  Assume they're Points.
    for(int i=0; i<sz; i++) {
      PyObject *point = PyList_GET_ITEM(ptlist, i); // Point object
      PyObject *x = PyObject_GetAttrString(point, "x");
      PyObject *y = PyObject_GetAttrString(point, "y");
      if(!(x && y)) {
// 	std::cerr << PyString_AsString(PyObject_Repr(point)) << std::endl;
	PyErr_SetString(PyExc_AttributeError,
			"Curve component doesn't have x and y attributes.");
	return NULL;
      }
      pts->coords[2*i] = PyFloat_AsDouble(x);
      pts->coords[2*i+1] = PyFloat_AsDouble(y);
      Py_XDECREF(x);
      Py_XDECREF(y);
    }
  }
  _arg1 = pts;
  Py_XDECREF(ptlist);
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_draw_curve(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
{
  gtk_canvas_points_unref(pts);
}
    return _resultobj;
}

#define OOFCanvas_draw_polygon(_swigobj,_swigarg0)  (_swigobj->draw_polygon(_swigarg0))
static PyObject *_wrap_OOFCanvas_draw_polygon(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    GtkCanvasPoints * _arg1;
    PyObject * _argo0 = 0;
    GtkCanvasPoints * pts;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_draw_polygon",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_draw_polygon. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *ptlist = PyObject_CallMethod(_obj1, "points", NULL);
  if(!PyList_Check(ptlist)) {
    PyErr_SetString(PyExc_TypeError, "Typemap snafu!");
    return NULL;
  }
  int sz = PyList_Size(ptlist);
  pts = gtk_canvas_points_new(sz);

  // Here we have to check to see if we have a List of Points or
  // Coords.  Points are Python objects with .x and .y members.
  // Coords are C++ objects already, but we have to decipher the SWIG
  // pointer to find out where they are.

  PyObject *firstpoint = PyList_GET_ITEM(ptlist, 0);
  if(PyObject_HasAttrString(firstpoint, "this")) {
    // The PyObject is a swigged object.  Assume it's a Coord.
    for(int i=0; i<sz; i++) {
      PyObject *swiggedcoord = PyList_GET_ITEM(ptlist, i);
      Coord *coord;
      PyObject *sobj = PyObject_GetAttrString(swiggedcoord, "this");
      char *str = PyString_AsString(sobj);
      Py_XDECREF(sobj);
      if(SWIG_GetPtr(str, (void**) &coord, "_Coord_p")) {
	PyErr_SetString(PyExc_TypeError,
			"Type error in curve typemap: expected _Coord_p");
	return NULL;
      }
      pts->coords[2*i] = (*coord)(0);
      pts->coords[2*i+1] = (*coord)(1);
    }
  }
  else {
    // We have a list of pure Python objects.  Assume they're Points.
    for(int i=0; i<sz; i++) {
      PyObject *point = PyList_GET_ITEM(ptlist, i); // Point object
      PyObject *x = PyObject_GetAttrString(point, "x");
      PyObject *y = PyObject_GetAttrString(point, "y");
      if(!(x && y)) {
// 	std::cerr << PyString_AsString(PyObject_Repr(point)) << std::endl;
	PyErr_SetString(PyExc_AttributeError,
			"Curve component doesn't have x and y attributes.");
	return NULL;
      }
      pts->coords[2*i] = PyFloat_AsDouble(x);
      pts->coords[2*i+1] = PyFloat_AsDouble(y);
      Py_XDECREF(x);
      Py_XDECREF(y);
    }
  }
  _arg1 = pts;
  Py_XDECREF(ptlist);
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_draw_polygon(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
{
  gtk_canvas_points_unref(pts);
}
    return _resultobj;
}

#define OOFCanvas_fill_polygon(_swigobj,_swigarg0)  (_swigobj->fill_polygon(_swigarg0))
static PyObject *_wrap_OOFCanvas_fill_polygon(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    GtkCanvasPoints * _arg1;
    PyObject * _argo0 = 0;
    GtkCanvasPoints * pts;
    PyObject * _obj1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_fill_polygon",&_argo0,&_obj1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_fill_polygon. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  PyObject *ptlist = PyObject_CallMethod(_obj1, "points", NULL);
  if(!PyList_Check(ptlist)) {
    PyErr_SetString(PyExc_TypeError, "Typemap snafu!");
    return NULL;
  }
  int sz = PyList_Size(ptlist);
  pts = gtk_canvas_points_new(sz);

  // Here we have to check to see if we have a List of Points or
  // Coords.  Points are Python objects with .x and .y members.
  // Coords are C++ objects already, but we have to decipher the SWIG
  // pointer to find out where they are.

  PyObject *firstpoint = PyList_GET_ITEM(ptlist, 0);
  if(PyObject_HasAttrString(firstpoint, "this")) {
    // The PyObject is a swigged object.  Assume it's a Coord.
    for(int i=0; i<sz; i++) {
      PyObject *swiggedcoord = PyList_GET_ITEM(ptlist, i);
      Coord *coord;
      PyObject *sobj = PyObject_GetAttrString(swiggedcoord, "this");
      char *str = PyString_AsString(sobj);
      Py_XDECREF(sobj);
      if(SWIG_GetPtr(str, (void**) &coord, "_Coord_p")) {
	PyErr_SetString(PyExc_TypeError,
			"Type error in curve typemap: expected _Coord_p");
	return NULL;
      }
      pts->coords[2*i] = (*coord)(0);
      pts->coords[2*i+1] = (*coord)(1);
    }
  }
  else {
    // We have a list of pure Python objects.  Assume they're Points.
    for(int i=0; i<sz; i++) {
      PyObject *point = PyList_GET_ITEM(ptlist, i); // Point object
      PyObject *x = PyObject_GetAttrString(point, "x");
      PyObject *y = PyObject_GetAttrString(point, "y");
      if(!(x && y)) {
// 	std::cerr << PyString_AsString(PyObject_Repr(point)) << std::endl;
	PyErr_SetString(PyExc_AttributeError,
			"Curve component doesn't have x and y attributes.");
	return NULL;
      }
      pts->coords[2*i] = PyFloat_AsDouble(x);
      pts->coords[2*i+1] = PyFloat_AsDouble(y);
      Py_XDECREF(x);
      Py_XDECREF(y);
    }
  }
  _arg1 = pts;
  Py_XDECREF(ptlist);
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_fill_polygon(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
{
  gtk_canvas_points_unref(pts);
}
    return _resultobj;
}

#define OOFCanvas_draw_circle(_swigobj,_swigarg0,_swigarg1)  (_swigobj->draw_circle(_swigarg0,_swigarg1))
static PyObject *_wrap_OOFCanvas_draw_circle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    Coord * _arg1;
    double  _arg2;
    PyObject * _argo0 = 0;
    PyObject * _argo1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OOd:OOFCanvas_draw_circle",&_argo0,&_argo1,&_arg2)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_draw_circle. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
    if (_argo1) {
        if (_argo1 == Py_None) { _arg1 = NULL; }
        else if (SWIG_GetPtrObj(_argo1,(void **) &_arg1,"_Coord_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of OOFCanvas_draw_circle. Expected _Coord_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_draw_circle(_arg0,*_arg1,_arg2);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_fill_circle(_swigobj,_swigarg0,_swigarg1)  (_swigobj->fill_circle(_swigarg0,_swigarg1))
static PyObject *_wrap_OOFCanvas_fill_circle(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    Coord * _arg1;
    double  _arg2;
    PyObject * _argo0 = 0;
    PyObject * _argo1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OOd:OOFCanvas_fill_circle",&_argo0,&_argo1,&_arg2)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_fill_circle. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
    if (_argo1) {
        if (_argo1 == Py_None) { _arg1 = NULL; }
        else if (SWIG_GetPtrObj(_argo1,(void **) &_arg1,"_Coord_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of OOFCanvas_fill_circle. Expected _Coord_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_fill_circle(_arg0,*_arg1,_arg2);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_draw_image(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5)  (_swigobj->draw_image(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5))
static PyObject *_wrap_OOFCanvas_draw_image(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    StringImage * _arg1;
    int  _arg2;
    int  _arg3;
    Coord * _arg4;
    double  _arg5;
    double  _arg6;
    PyObject * _argo0 = 0;
    PyObject * _argo1 = 0;
    PyObject * _argo4 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OOiiOdd:OOFCanvas_draw_image",&_argo0,&_argo1,&_arg2,&_arg3,&_argo4,&_arg5,&_arg6)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_draw_image. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
    if (_argo1) {
        if (_argo1 == Py_None) { _arg1 = NULL; }
        else if (SWIG_GetPtrObj(_argo1,(void **) &_arg1,"_StringImage_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of OOFCanvas_draw_image. Expected _StringImage_p.");
        return NULL;
        }
    }
    if (_argo4) {
        if (_argo4 == Py_None) { _arg4 = NULL; }
        else if (SWIG_GetPtrObj(_argo4,(void **) &_arg4,"_Coord_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of OOFCanvas_draw_image. Expected _Coord_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_draw_image(_arg0,_arg1,_arg2,_arg3,*_arg4,_arg5,_arg6);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_draw_shaped_image(_swigobj,_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6)  (_swigobj->draw_shaped_image(_swigarg0,_swigarg1,_swigarg2,_swigarg3,_swigarg4,_swigarg5,_swigarg6))
static PyObject *_wrap_OOFCanvas_draw_shaped_image(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    StringImage * _arg1;
    int  _arg2;
    int  _arg3;
    Coord * _arg4;
    double  _arg5;
    double  _arg6;
    GdkImlibColor * _arg7;
    PyObject * _argo0 = 0;
    PyObject * _argo1 = 0;
    PyObject * _argo4 = 0;
    GdkImlibColor  tmp;
    PyObject * _obj7 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OOiiOddO:OOFCanvas_draw_shaped_image",&_argo0,&_argo1,&_arg2,&_arg3,&_argo4,&_arg5,&_arg6,&_obj7)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_draw_shaped_image. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
    if (_argo1) {
        if (_argo1 == Py_None) { _arg1 = NULL; }
        else if (SWIG_GetPtrObj(_argo1,(void **) &_arg1,"_StringImage_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of OOFCanvas_draw_shaped_image. Expected _StringImage_p.");
        return NULL;
        }
    }
    if (_argo4) {
        if (_argo4 == Py_None) { _arg4 = NULL; }
        else if (SWIG_GetPtrObj(_argo4,(void **) &_arg4,"_Coord_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 5 of OOFCanvas_draw_shaped_image. Expected _Coord_p.");
        return NULL;
        }
    }
{
  PyObject *redobj = PyObject_CallMethod(_obj7, "getRed", NULL);
  PyObject *grnobj = PyObject_CallMethod(_obj7, "getGreen", NULL);
  PyObject *bluobj = PyObject_CallMethod(_obj7, "getBlue", NULL);
  if(!(redobj && grnobj && bluobj)) {
    PyErr_SetString(PyExc_TypeError, "GdkImlibColor* typemap: Failed to evaluate Color.");
    return NULL;
  }
  tmp.r = int(255*PyFloat_AsDouble(redobj));
  tmp.g = int(255*PyFloat_AsDouble(grnobj));
  tmp.b = int(255*PyFloat_AsDouble(bluobj));
  _arg7 = &tmp;
  Py_XDECREF(redobj);
  Py_XDECREF(grnobj);
  Py_XDECREF(bluobj);
}
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_draw_shaped_image(_arg0,_arg1,_arg2,_arg3,*_arg4,_arg5,_arg6,_arg7);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvas_set_rubberband(_swigobj,_swigarg0)  (_swigobj->set_rubberband(_swigarg0))
static PyObject *_wrap_OOFCanvas_set_rubberband(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvas * _arg0;
    RubberBand * _arg1;
    PyObject * _argo0 = 0;
    PyObject * _argo1 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"OO:OOFCanvas_set_rubberband",&_argo0,&_argo1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvas_set_rubberband. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
    if (_argo1) {
        if (_argo1 == Py_None) { _arg1 = NULL; }
        else if (SWIG_GetPtrObj(_argo1,(void **) &_arg1,"_RubberBand_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 2 of OOFCanvas_set_rubberband. Expected _RubberBand_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvas_set_rubberband(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static void *SwigScrolledOOFCanvasToOOFCanvas(void *ptr) {
    ScrolledOOFCanvas *src;
    OOFCanvas *dest;
    src = (ScrolledOOFCanvas *) ptr;
    dest = (OOFCanvas *) src;
    return (void *) dest;
}

#define new_ScrolledOOFCanvas(_swigarg0) (new ScrolledOOFCanvas(_swigarg0))
static PyObject *_wrap_new_ScrolledOOFCanvas(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    ScrolledOOFCanvas * _result;
    bool  _arg0;
    int tempbool0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"i:new_ScrolledOOFCanvas",&tempbool0)) 
        return NULL;
    _arg0 = (bool ) tempbool0;
{
  try {
    installSignals;
    releasePyLock();
        _result = (ScrolledOOFCanvas *)new_ScrolledOOFCanvas(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    if (_result) {
        SWIG_MakePtr(_ptemp, (char *) _result,"_ScrolledOOFCanvas_p");
        _resultobj = Py_BuildValue("s",_ptemp);
    } else {
        Py_INCREF(Py_None);
        _resultobj = Py_None;
    }
    return _resultobj;
}

#define new_OOFCanvasLayer(_swigarg0) (new OOFCanvasLayer(_swigarg0))
static PyObject *_wrap_new_OOFCanvasLayer(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _result;
    OOFCanvas * _arg0;
    PyObject * _argo0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"O:new_OOFCanvasLayer",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvas_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of new_OOFCanvasLayer. Expected _OOFCanvas_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (OOFCanvasLayer *)new_OOFCanvasLayer(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    if (_result) {
        SWIG_MakePtr(_ptemp, (char *) _result,"_OOFCanvasLayer_p");
        _resultobj = Py_BuildValue("s",_ptemp);
    } else {
        Py_INCREF(Py_None);
        _resultobj = Py_None;
    }
    return _resultobj;
}

#define delete_OOFCanvasLayer(_swigobj) (delete _swigobj)
static PyObject *_wrap_delete_OOFCanvasLayer(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:delete_OOFCanvasLayer",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of delete_OOFCanvasLayer. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        delete_OOFCanvasLayer(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvasLayer_group(_swigobj)  (_swigobj->group())
static PyObject *_wrap_OOFCanvasLayer_group(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    GtkCanvasGroup * _result;
    OOFCanvasLayer * _arg0;
    PyObject * _argo0 = 0;
    char _ptemp[128];

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvasLayer_group",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_group. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        _result = (GtkCanvasGroup *)OOFCanvasLayer_group(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    if (_result) {
        SWIG_MakePtr(_ptemp, (char *) _result,"_GtkCanvasGroup_p");
        _resultobj = Py_BuildValue("s",_ptemp);
    } else {
        Py_INCREF(Py_None);
        _resultobj = Py_None;
    }
    return _resultobj;
}

#define OOFCanvasLayer_raise_layer(_swigobj,_swigarg0)  (_swigobj->raise_layer(_swigarg0))
static PyObject *_wrap_OOFCanvasLayer_raise_layer(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    int  _arg1;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"Oi:OOFCanvasLayer_raise_layer",&_argo0,&_arg1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_raise_layer. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvasLayer_raise_layer(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvasLayer_raise_to_top(_swigobj)  (_swigobj->raise_to_top())
static PyObject *_wrap_OOFCanvasLayer_raise_to_top(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvasLayer_raise_to_top",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_raise_to_top. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvasLayer_raise_to_top(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvasLayer_lower_layer(_swigobj,_swigarg0)  (_swigobj->lower_layer(_swigarg0))
static PyObject *_wrap_OOFCanvasLayer_lower_layer(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    int  _arg1;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"Oi:OOFCanvasLayer_lower_layer",&_argo0,&_arg1)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_lower_layer. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvasLayer_lower_layer(_arg0,_arg1);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvasLayer_show(_swigobj)  (_swigobj->show())
static PyObject *_wrap_OOFCanvasLayer_show(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvasLayer_show",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_show. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvasLayer_show(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvasLayer_hide(_swigobj)  (_swigobj->hide())
static PyObject *_wrap_OOFCanvasLayer_hide(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvasLayer_hide",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_hide. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvasLayer_hide(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvasLayer_move(_swigobj,_swigarg0,_swigarg1)  (_swigobj->move(_swigarg0,_swigarg1))
static PyObject *_wrap_OOFCanvasLayer_move(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    double  _arg1;
    double  _arg2;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"Odd:OOFCanvasLayer_move",&_argo0,&_arg1,&_arg2)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_move. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvasLayer_move(_arg0,_arg1,_arg2);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvasLayer_clear(_swigobj)  (_swigobj->clear())
static PyObject *_wrap_OOFCanvasLayer_clear(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvasLayer_clear",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_clear. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvasLayer_clear(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvasLayer_make_current(_swigobj)  (_swigobj->make_current())
static PyObject *_wrap_OOFCanvasLayer_make_current(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvasLayer_make_current",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_make_current. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvasLayer_make_current(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

#define OOFCanvasLayer_destroy(_swigobj)  (_swigobj->destroy())
static PyObject *_wrap_OOFCanvasLayer_destroy(PyObject *self, PyObject *args) {
    PyObject * _resultobj;
    OOFCanvasLayer * _arg0;
    PyObject * _argo0 = 0;

    self = self;
    if(!PyArg_ParseTuple(args,"O:OOFCanvasLayer_destroy",&_argo0)) 
        return NULL;
    if (_argo0) {
        if (_argo0 == Py_None) { _arg0 = NULL; }
        else if (SWIG_GetPtrObj(_argo0,(void **) &_arg0,"_OOFCanvasLayer_p")) {
            PyErr_SetString(PyExc_TypeError,"Type error in argument 1 of OOFCanvasLayer_destroy. Expected _OOFCanvasLayer_p.");
        return NULL;
        }
    }
{
  try {
    installSignals;
    releasePyLock();
        OOFCanvasLayer_destroy(_arg0);
;
    acquirePyLock();
    restoreSignals;
  }
  catch (PythonError &p) {
    // In this case, the Python error indicator is already set.
    acquirePyLock();
    restoreSignals;
    return 0;
  }
  catch (ErrError &e) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",e.pythonequiv().c_str() );
    PyEval_CallObject((PyObject *)e.pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
  catch (...) {
    acquirePyLock();
    restoreSignals;
    PyObject *args = Py_BuildValue("(s)",
				   "ErrPyProgrammingError('Caught an unexpected C++ exception!')");
    PyEval_CallObject((PyObject*) ErrError::pyconverter, args);
    Py_DECREF(args);
    return 0;
  }
}    Py_INCREF(Py_None);
    _resultobj = Py_None;
    return _resultobj;
}

static PyMethodDef oofcanvascMethods[] = {
	 { "OOFCanvasLayer_destroy", _wrap_OOFCanvasLayer_destroy, METH_VARARGS },
	 { "OOFCanvasLayer_make_current", _wrap_OOFCanvasLayer_make_current, METH_VARARGS },
	 { "OOFCanvasLayer_clear", _wrap_OOFCanvasLayer_clear, METH_VARARGS },
	 { "OOFCanvasLayer_move", _wrap_OOFCanvasLayer_move, METH_VARARGS },
	 { "OOFCanvasLayer_hide", _wrap_OOFCanvasLayer_hide, METH_VARARGS },
	 { "OOFCanvasLayer_show", _wrap_OOFCanvasLayer_show, METH_VARARGS },
	 { "OOFCanvasLayer_lower_layer", _wrap_OOFCanvasLayer_lower_layer, METH_VARARGS },
	 { "OOFCanvasLayer_raise_to_top", _wrap_OOFCanvasLayer_raise_to_top, METH_VARARGS },
	 { "OOFCanvasLayer_raise_layer", _wrap_OOFCanvasLayer_raise_layer, METH_VARARGS },
	 { "OOFCanvasLayer_group", _wrap_OOFCanvasLayer_group, METH_VARARGS },
	 { "delete_OOFCanvasLayer", _wrap_delete_OOFCanvasLayer, METH_VARARGS },
	 { "new_OOFCanvasLayer", _wrap_new_OOFCanvasLayer, METH_VARARGS },
	 { "new_ScrolledOOFCanvas", _wrap_new_ScrolledOOFCanvas, METH_VARARGS },
	 { "OOFCanvas_set_rubberband", _wrap_OOFCanvas_set_rubberband, METH_VARARGS },
	 { "OOFCanvas_draw_shaped_image", _wrap_OOFCanvas_draw_shaped_image, METH_VARARGS },
	 { "OOFCanvas_draw_image", _wrap_OOFCanvas_draw_image, METH_VARARGS },
	 { "OOFCanvas_fill_circle", _wrap_OOFCanvas_fill_circle, METH_VARARGS },
	 { "OOFCanvas_draw_circle", _wrap_OOFCanvas_draw_circle, METH_VARARGS },
	 { "OOFCanvas_fill_polygon", _wrap_OOFCanvas_fill_polygon, METH_VARARGS },
	 { "OOFCanvas_draw_polygon", _wrap_OOFCanvas_draw_polygon, METH_VARARGS },
	 { "OOFCanvas_draw_curve", _wrap_OOFCanvas_draw_curve, METH_VARARGS },
	 { "OOFCanvas_draw_segments", _wrap_OOFCanvas_draw_segments, METH_VARARGS },
	 { "OOFCanvas_draw_segment", _wrap_OOFCanvas_draw_segment, METH_VARARGS },
	 { "OOFCanvas_draw_triangle", _wrap_OOFCanvas_draw_triangle, METH_VARARGS },
	 { "OOFCanvas_draw_dot", _wrap_OOFCanvas_draw_dot, METH_VARARGS },
	 { "OOFCanvas_set_margin", _wrap_OOFCanvas_set_margin, METH_VARARGS },
	 { "OOFCanvas_set_bgColor", _wrap_OOFCanvas_set_bgColor, METH_VARARGS },
	 { "OOFCanvas_set_underlay_params", _wrap_OOFCanvas_set_underlay_params, METH_VARARGS },
	 { "OOFCanvas_set_fillColor", _wrap_OOFCanvas_set_fillColor, METH_VARARGS },
	 { "OOFCanvas_set_lineColor", _wrap_OOFCanvas_set_lineColor, METH_VARARGS },
	 { "OOFCanvas_set_lineWidth", _wrap_OOFCanvas_set_lineWidth, METH_VARARGS },
	 { "OOFCanvas_is_empty", _wrap_OOFCanvas_is_empty, METH_VARARGS },
	 { "OOFCanvas_clear", _wrap_OOFCanvas_clear, METH_VARARGS },
	 { "OOFCanvas_show", _wrap_OOFCanvas_show, METH_VARARGS },
	 { "OOFCanvas_set_configure_callback", _wrap_OOFCanvas_set_configure_callback, METH_VARARGS },
	 { "OOFCanvas_set_mouse_callback", _wrap_OOFCanvas_set_mouse_callback, METH_VARARGS },
	 { "OOFCanvas_deleteLayer", _wrap_OOFCanvas_deleteLayer, METH_VARARGS },
	 { "OOFCanvas_newLayer", _wrap_OOFCanvas_newLayer, METH_VARARGS },
	 { "OOFCanvas_set_vadjustment", _wrap_OOFCanvas_set_vadjustment, METH_VARARGS },
	 { "OOFCanvas_set_hadjustment", _wrap_OOFCanvas_set_hadjustment, METH_VARARGS },
	 { "OOFCanvas_window_coord", _wrap_OOFCanvas_window_coord, METH_VARARGS },
	 { "OOFCanvas_world_coord", _wrap_OOFCanvas_world_coord, METH_VARARGS },
	 { "OOFCanvas_get_height_in_pixels", _wrap_OOFCanvas_get_height_in_pixels, METH_VARARGS },
	 { "OOFCanvas_get_width_in_pixels", _wrap_OOFCanvas_get_width_in_pixels, METH_VARARGS },
	 { "OOFCanvas_get_bounds", _wrap_OOFCanvas_get_bounds, METH_VARARGS },
	 { "OOFCanvas_set_scrollregion", _wrap_OOFCanvas_set_scrollregion, METH_VARARGS },
	 { "OOFCanvas_get_scrollregion", _wrap_OOFCanvas_get_scrollregion, METH_VARARGS },
	 { "OOFCanvas_zoom", _wrap_OOFCanvas_zoom, METH_VARARGS },
	 { "OOFCanvas_set_pixels_per_unit", _wrap_OOFCanvas_set_pixels_per_unit, METH_VARARGS },
	 { "OOFCanvas_get_pixels_per_unit", _wrap_OOFCanvas_get_pixels_per_unit, METH_VARARGS },
	 { "OOFCanvas_close", _wrap_OOFCanvas_close, METH_VARARGS },
	 { "OOFCanvas_attach_self_to_table", _wrap_OOFCanvas_attach_self_to_table, METH_VARARGS },
	 { "OOFCanvas_add_self", _wrap_OOFCanvas_add_self, METH_VARARGS },
	 { "delete_OOFCanvas", _wrap_delete_OOFCanvas, METH_VARARGS },
	 { "new_OOFCanvas", _wrap_new_OOFCanvas, METH_VARARGS },
	 { NULL, NULL }
};
#ifdef __cplusplus
}
#endif
/*
 * This table is used by the pointer type-checker
 */
static struct { char *n1; char *n2; void *(*pcnv)(void *); } _swig_mapping[] = {
    { "_signed_long","_long",0},
    { "_class_OOFCanvasLayer","_OOFCanvasLayer",0},
    { "_class_ICoord","_ICoord",0},
    { "_long","_unsigned_long",0},
    { "_long","_signed_long",0},
    { "_class_CRectangle","_CRectangle",0},
    { "_class_CPolygonCoord","_CPolygonCoord",0},
    { "_class_ScrolledOOFCanvas","_ScrolledOOFCanvas",0},
    { "_CSegment","_class_CSegment",0},
    { "_Position","_class_Position",0},
    { "_unsigned_long","_long",0},
    { "_OOFCanvasLayer","_class_OOFCanvasLayer",0},
    { "_signed_int","_int",0},
    { "_class_Coord","_Coord",0},
    { "_unsigned_short","_short",0},
    { "_OOFCanvas","_class_ScrolledOOFCanvas",SwigScrolledOOFCanvasToOOFCanvas},
    { "_OOFCanvas","_ScrolledOOFCanvas",SwigScrolledOOFCanvasToOOFCanvas},
    { "_OOFCanvas","_class_OOFCanvas",0},
    { "_signed_short","_short",0},
    { "_unsigned_int","_int",0},
    { "_ScrolledOOFCanvas","_class_ScrolledOOFCanvas",0},
    { "_short","_unsigned_short",0},
    { "_short","_signed_short",0},
    { "_class_OOFCanvas","_class_ScrolledOOFCanvas",SwigScrolledOOFCanvasToOOFCanvas},
    { "_class_OOFCanvas","_ScrolledOOFCanvas",SwigScrolledOOFCanvasToOOFCanvas},
    { "_class_OOFCanvas","_OOFCanvas",0},
    { "_int","_unsigned_int",0},
    { "_int","_signed_int",0},
    { "_class_CSegment","_CSegment",0},
    { "_CRectangle","_class_CRectangle",0},
    { "_class_Position","_Position",0},
    { "_CPolygonCoord","_class_CPolygonCoord",0},
    { "_Coord","_class_Coord",0},
    { "_ICoord","_class_ICoord",0},
{0,0,0}};

static PyObject *SWIG_globals;
#ifdef __cplusplus
extern "C" 
#endif
SWIGEXPORT(void) initoofcanvasc() {
	 PyObject *m, *d;
	 SWIG_globals = SWIG_newvarlink();
	 m = Py_InitModule("oofcanvasc", oofcanvascMethods);
	 d = PyModule_GetDict(m);
{
   int i;
   for (i = 0; _swig_mapping[i].n1; i++)
        SWIG_RegisterMapping(_swig_mapping[i].n1,_swig_mapping[i].n2,_swig_mapping[i].pcnv);
}
}
