# -*- python -*-
# $RCSfile: toolboxGUI.py,v $
# $Revision: 1.12 $
# $Author: langer $
# $Date: 2005/05/13 18:43:59 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from gtk import *
from oof2.common import debug
from oof2.common import toolbox

class GfxToolbox:
    def __init__(self, name, toolbox):
        debug.mainthreadTest()
        self.toolbox = toolbox          # non-GUI toolbox
        self.gtk = GtkFrame()           # root of toolbox's gtk widget tree
        self.gtk.set_shadow_type(SHADOW_NONE)
        self.active = 0
        self._name = name
    def name(self):
        return self._name
    def close(self):
        pass
    def activate(self):
        self.active = 1
    def deactivate(self):
        self.active = 0
    def gfxwindow(self):
        return self.toolbox.gfxwindow()
    def __cmp__(self, other):           # for sorting in gfxwindow's list
        return cmp(self.toolbox.ordering, other.toolbox.ordering)


# The base Toolbox class doesn't make a GUI, but it provides a trivial
# makeGUI function so that derived toolboxes that don't create a GUI
# don't have to define makeGUI themselves.

def _makeGUI(self):
    pass

toolbox.Toolbox.makeGUI = _makeGUI
