# -*- python -*-
# $RCSfile: pixelinfoGUI.py,v $
# $Revision: 1.11 $
# $Author: langer $
# $Date: 2005/05/13 18:44:23 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.SWIG.image import oofimage
from oof2.common import debug
from oof2.common.IO.GUI import pixelinfoGUI
from gtk import *

## TODO: This needs to detect Image modifications.

class ImagePlugIn(pixelinfoGUI.PixelInfoPlugIn):
    ordering = 1
    nrows = 4
    def __init__(self, toolbox, table, row):
        debug.mainthreadTest()
        pixelinfoGUI.PixelInfoPlugIn.__init__(self, toolbox)
        
        label = GtkLabel('image=')
        label.set_alignment(1.0, 0.5)
        table.attach(label, 0,1, row,row+1, xpadding=5, xoptions=FILL)
        self.imagetext = GtkEntry()
        self.imagetext.set_editable(0)
        table.attach(self.imagetext, 1,2, row,row+1,
                     xpadding=5, xoptions=EXPAND|FILL)

        label = GtkLabel('red=')
        label.set_alignment(1.0, 0.5)
        table.attach(label, 0,1, row+1,row+2, xpadding=5, xoptions=FILL)
        self.redtext = GtkEntry()
        self.redtext.set_editable(0)
        table.attach(self.redtext, 1,2, row+1,row+2,
                     xpadding=5, xoptions=EXPAND|FILL)

        label = GtkLabel('green=')
        label.set_alignment(1.0, 0.5)
        table.attach(label, 0,1, row+2,row+3, xpadding=5, xoptions=FILL)
        self.greentext = GtkEntry()
        self.greentext.set_editable(0)
        table.attach(self.greentext, 1,2, row+2,row+3,
                     xpadding=5, xoptions=EXPAND|FILL)

        label = GtkLabel('blue=')
        label.set_alignment(1.0, 0.5)
        table.attach(label, 0,1, row+3,row+4, xpadding=5, xoptions=FILL)
        self.bluetext = GtkEntry()
        self.bluetext.set_editable(0)
        table.attach(self.bluetext, 1,2, row+3,row+4,
                     xpadding=5, xoptions=EXPAND|FILL)

    def update(self, where):
        debug.mainthreadTest()
        # If the topmost Image in the display is obscured by a
        # Microstructure, then Image data is not displayed in the
        # toolbox.  This is because it wouldn't be clear which Image
        # the data is from, if the Microstructure has more than one
        # Image or if the Image is from a different Microstructure.
        image = self.toolbox.gfxwindow().topmost('Image', 'Microstructure')
        if isinstance(image, oofimage.OOFImagePtr) and where is not None:
            imagecontext = self.toolbox.gfxwindow().topwho('Image')
            self.imagetext.set_text(imagecontext.path())
            color = image[where]
            self.redtext.set_text(`color.getRed()`)
            self.greentext.set_text(`color.getGreen()`)
            self.bluetext.set_text(`color.getBlue()`)
        else:
            self.imagetext.set_text('(No image)')
            self.redtext.set_text('')
            self.greentext.set_text('')
            self.bluetext.set_text('')

    def nonsense(self):
        debug.mainthreadTest()
        self.imagetext.set_text('???')
        self.redtext.set_text('???')
        self.greentext.set_text('???')
        self.bluetext.set_text('???')


pixelinfoGUI.registerPlugInClass(ImagePlugIn)

